// parameter class definitions
// automatically generated by make-parameter-class
// part of libecsb - the executable cell systems biology library
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#include "POptimizerParameters.h"

#include <string.h>
#include <stdlib.h>
#include <iostream>
#include <libgen.h>
#include <unistd.h>

// constructor
POptimizerParameters::POptimizerParameters(void) : ParameterSet("POptimizerParameters")
{
	// set initial values
}

// set a parameter value
bool POptimizerParameters::setParameter(char *name, char *value)
{
	if(strcmp(name, "num_initials") == 0) {
		num_initials = atoi(value);
		return true;
	}
	if(strcmp(name, "target_file") == 0) {
		char path[PARAMETER_STR_MAX];
		strncpy(path, value, PARAMETER_STR_MAX);
		char *path2 = dirname(path);
		if(access(path2, F_OK) != 0) {
			std::cerr << "error: unable to access file " << value << "\n";
			exit(EXIT_FAILURE);
		}
		strncpy(target_file, value, PARAMETER_STR_MAX);
		target_file[PARAMETER_STR_MAX - 1] = '\0';
		return true;
	}
	if(strcmp(name, "initial_file") == 0) {
		char path[PARAMETER_STR_MAX];
		strncpy(path, value, PARAMETER_STR_MAX);
		char *path2 = dirname(path);
		if(access(path2, F_OK) != 0) {
			std::cerr << "error: unable to access file " << value << "\n";
			exit(EXIT_FAILURE);
		}
		strncpy(initial_file, value, PARAMETER_STR_MAX);
		initial_file[PARAMETER_STR_MAX - 1] = '\0';
		return true;
	}
	if(strcmp(name, "nonfix_module_lib_file") == 0) {
		char path[PARAMETER_STR_MAX];
		strncpy(path, value, PARAMETER_STR_MAX);
		char *path2 = dirname(path);
		if(access(path2, F_OK) != 0) {
			std::cerr << "error: unable to access file " << value << "\n";
			exit(EXIT_FAILURE);
		}
		strncpy(nonfix_module_lib_file, value, PARAMETER_STR_MAX);
		nonfix_module_lib_file[PARAMETER_STR_MAX - 1] = '\0';
		return true;
	}
	if(strcmp(name, "fix_module_lib_file") == 0) {
		char path[PARAMETER_STR_MAX];
		strncpy(path, value, PARAMETER_STR_MAX);
		char *path2 = dirname(path);
		if(access(path2, F_OK) != 0) {
			std::cerr << "error: unable to access file " << value << "\n";
			exit(EXIT_FAILURE);
		}
		strncpy(fix_module_lib_file, value, PARAMETER_STR_MAX);
		fix_module_lib_file[PARAMETER_STR_MAX - 1] = '\0';
		return true;
	}
	if(strcmp(name, "molecules") == 0) {
		strncpy(molecules, value, PARAMETER_STR_MAX);
		molecules[PARAMETER_STR_MAX - 1] = '\0';
		return true;
	}
	if(strcmp(name, "para_opti_algo") == 0) {
		if(!(strcmp(value, "DE") == 0 || strcmp(value, "GA") == 0 || strcmp(value, "EDA") == 0 || strcmp(value, "CMA-ES") == 0)) {
			std::cerr << "error: invalid value \"" << value << \
					"\" for parameter para_opti_algo\n";
			exit(EXIT_FAILURE);
		}
		strncpy(para_opti_algo, value, PARAMETER_STR_MAX);
		para_opti_algo[PARAMETER_STR_MAX - 1] = '\0';
		return true;
	}
	if(strcmp(name, "fitness_func_type") == 0) {
		if(!(strcmp(value, "RandomWeightedSum") == 0 || strcmp(value, "EqualWeightedSum") == 0)) {
			std::cerr << "error: invalid value \"" << value << \
					"\" for parameter fitness_func_type\n";
			exit(EXIT_FAILURE);
		}
		strncpy(fitness_func_type, value, PARAMETER_STR_MAX);
		fitness_func_type[PARAMETER_STR_MAX - 1] = '\0';
		return true;
	}
	if(strcmp(name, "target_obj_num") == 0) {
		if(atoi(value) < 1) {
			std::cerr << "error: value " << atoi(value) << \
					" out of range for parameter target_obj_num\n";
			exit(EXIT_FAILURE);
		}
		target_obj_num = atoi(value);
		return true;
	}
	if(strcmp(name, "maxtime") == 0) {
		maxtime = (float) atof(value);
		return true;
	}
	if(strcmp(name, "interval") == 0) {
		interval = (float) atof(value);
		return true;
	}
	if(strcmp(name, "maxmodulesno") == 0) {
		if(atoi(value) < 1) {
			std::cerr << "error: value " << atoi(value) << \
					" out of range for parameter maxmodulesno\n";
			exit(EXIT_FAILURE);
		}
		maxmodulesno = atoi(value);
		return true;
	}
	if(strcmp(name, "simu_runs") == 0) {
		if(atoi(value) < 1) {
			std::cerr << "error: value " << atoi(value) << \
					" out of range for parameter simu_runs\n";
			exit(EXIT_FAILURE);
		}
		simu_runs = atoi(value);
		return true;
	}
	if(strcmp(name, "seednum") == 0) {
		seednum = atol(value);
		return true;
	}
	if(strcmp(name, "show_progress") == 0) {
		if(strcmp(value, "true") == 0 || *value == '1')
			show_progress = true;
		else
			show_progress = false;
		return true;
	}
	if(strcmp(name, "debug_mode") == 0) {
		if(strcmp(value, "true") == 0 || *value == '1')
			debug_mode = true;
		else
			debug_mode = false;
		return true;
	}
	if(strcmp(name, "popsize") == 0) {
		popsize = atoi(value);
		return true;
	}
	if(strcmp(name, "maxgeno") == 0) {
		maxgeno = atoi(value);
		return true;
	}
	if(strcmp(name, "percent_paraopti") == 0) {
		if(atof(value) > 1.000000) {
			std::cerr << "error: value " << atof(value) << \
					" out of range for parameter percent_paraopti\n";
			exit(EXIT_FAILURE);
		}
		if(atof(value) < 0.000000) {
			std::cerr << "error: value " << atof(value) << \
					" out of range for parameter percent_paraopti\n";
			exit(EXIT_FAILURE);
		}
		percent_paraopti = (float) atof(value);
		return true;
	}
	if(strcmp(name, "DE_psize") == 0) {
		DE_psize = atoi(value);
		return true;
	}
	if(strcmp(name, "DE_maxgeno") == 0) {
		DE_maxgeno = atoi(value);
		return true;
	}
	if(strcmp(name, "GA_psize") == 0) {
		GA_psize = atoi(value);
		return true;
	}
	if(strcmp(name, "GA_maxxo") == 0) {
		GA_maxxo = atoi(value);
		return true;
	}
	if(strcmp(name, "EDA_psize") == 0) {
		EDA_psize = atoi(value);
		return true;
	}
	if(strcmp(name, "EDA_maxgeno") == 0) {
		EDA_maxgeno = atoi(value);
		return true;
	}
	if(strcmp(name, "CMAES_maxgeno") == 0) {
		CMAES_maxgeno = atoi(value);
		return true;
	}

	return false;
}

// write parameter set to file
void POptimizerParameters::write(const char *filename)
{
	FILE *fp;

	// open output file
	if(!(fp = fopen(filename, "w"))) {
		std::cerr << "error: unable to open file " << filename << "\n";
		exit(EXIT_FAILURE);
	}

	// write xml header
	fprintf(fp, "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n");

	fprintf(fp, "<parameters xmlns=\"http://www.cpib.ac.uk/~jpt\"\n");
	fprintf(fp, "\txmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n");
	fprintf(fp, "\txsi:schemaLocation=\"http://www.cpib.ac.uk/~jpt parameter.xsd\">\n");

	// write parameter values
	fprintf(fp, "\n<!-- parameter definitions -->\n");
	fprintf(fp, "<parameterSet name=\"POptimizerParameters\">\n");
	fprintf(fp, "\t<parameter name=\"num_initials\" value=\"%d\"/>\n", num_initials);
	fprintf(fp, "\t<parameter name=\"target_file\" value=\"%s\"/>\n", target_file);
	fprintf(fp, "\t<parameter name=\"initial_file\" value=\"%s\"/>\n", initial_file);
	fprintf(fp, "\t<parameter name=\"nonfix_module_lib_file\" value=\"%s\"/>\n", nonfix_module_lib_file);
	fprintf(fp, "\t<parameter name=\"fix_module_lib_file\" value=\"%s\"/>\n", fix_module_lib_file);
	fprintf(fp, "\t<parameter name=\"molecules\" value=\"%s\"/>\n", molecules);
	fprintf(fp, "\t<parameter name=\"para_opti_algo\" value=\"%s\"/>\n", para_opti_algo);
	fprintf(fp, "\t<parameter name=\"fitness_func_type\" value=\"%s\"/>\n", fitness_func_type);
	fprintf(fp, "\t<parameter name=\"target_obj_num\" value=\"%d\"/>\n", target_obj_num);
	fprintf(fp, "\t<parameter name=\"maxtime\" value=\"%f\"/>\n", maxtime);
	fprintf(fp, "\t<parameter name=\"interval\" value=\"%f\"/>\n", interval);
	fprintf(fp, "\t<parameter name=\"maxmodulesno\" value=\"%d\"/>\n", maxmodulesno);
	fprintf(fp, "\t<parameter name=\"simu_runs\" value=\"%d\"/>\n", simu_runs);
	fprintf(fp, "\t<parameter name=\"seednum\" value=\"%ld\"/>\n", seednum);
	fprintf(fp, "\t<parameter name=\"show_progress\" value=\"%d\"/>\n", show_progress);
	fprintf(fp, "\t<parameter name=\"debug_mode\" value=\"%d\"/>\n", debug_mode);
	fprintf(fp, "\t<parameter name=\"popsize\" value=\"%d\"/>\n", popsize);
	fprintf(fp, "\t<parameter name=\"maxgeno\" value=\"%d\"/>\n", maxgeno);
	fprintf(fp, "\t<parameter name=\"percent_paraopti\" value=\"%f\"/>\n", percent_paraopti);
	fprintf(fp, "\t<parameter name=\"DE_psize\" value=\"%d\"/>\n", DE_psize);
	fprintf(fp, "\t<parameter name=\"DE_maxgeno\" value=\"%d\"/>\n", DE_maxgeno);
	fprintf(fp, "\t<parameter name=\"GA_psize\" value=\"%d\"/>\n", GA_psize);
	fprintf(fp, "\t<parameter name=\"GA_maxxo\" value=\"%d\"/>\n", GA_maxxo);
	fprintf(fp, "\t<parameter name=\"EDA_psize\" value=\"%d\"/>\n", EDA_psize);
	fprintf(fp, "\t<parameter name=\"EDA_maxgeno\" value=\"%d\"/>\n", EDA_maxgeno);
	fprintf(fp, "\t<parameter name=\"CMAES_maxgeno\" value=\"%d\"/>\n", CMAES_maxgeno);
	fprintf(fp, "</parameterSet>\n");

	// write xml trailer
	fprintf(fp, "\n</parameters>\n");

	// close output file
	fclose(fp);
}
