// parameter class definitions
// automatically generated by make-parameter-class
// part of libecsb - the executable cell systems biology library
// copyright 2008, 2009 jamie twycross, jpt AT cs.nott.ac.uk
// released under GNU GPL version 3

#ifndef POPTIMIZERPARAMETERS_H
#define POPTIMIZERPARAMETERS_H

#include <ecsb/ecsb.h>

// POptimizerParameters class
class POptimizerParameters : public ECSB::ParameterSet {
	public:
		// constructor
		POptimizerParameters(void);

		// parameters
		// the number of files for initial values
		int num_initials;
		// filename for target time series data
		char target_file[PARAMETER_STR_MAX];
		// filename for non-zero initial values settings of some objects
		char initial_file[PARAMETER_STR_MAX];
		// filename for the non-fixed module library to evolve models
		char nonfix_module_lib_file[PARAMETER_STR_MAX];
		// filename for the fixed module library
		char fix_module_lib_file[PARAMETER_STR_MAX];
		// the possible values for all variables when instantiate a module in the library
		char molecules[PARAMETER_STR_MAX];
		// the algorithm chosen to do the model parameter optimization
		char para_opti_algo[PARAMETER_STR_MAX];
		// the fitness function chosen to do the model quality evaluation
		char fitness_func_type[PARAMETER_STR_MAX];
		// the number of objects in the input time series data
		int target_obj_num;
		// the total simulation time of the input data
		float maxtime;
		// the interval time between two sampling data points of input data
		float interval;
		// the maximum number of modules contain in one model
		int maxmodulesno;
		// the number of simulations by running the simulator when calculating the fitness of one individual
		int simu_runs;
		// the seed number to initialize the random generator
		long seednum;
		// show progress of the optimization procedure
		bool show_progress;
		// print information to stdout useful for code debug
		bool debug_mode;
		// the population size to do the GA model structure optimization
		int popsize;
		// the maximum number of generations to terminate a GA run
		int maxgeno;
		// the percentage of the individuals in the model population to do the parameter optimization
		float percent_paraopti;
		// the population size in DE parameter optimization
		int DE_psize;
		// the maximum number of generations to evolve the best parameter set with DE
		int DE_maxgeno;
		// the population size in GA parameter optimization
		int GA_psize;
		// the number of multi_parent crossover performed in GA parameter optimization
		int GA_maxxo;
		// the population size in EDA parameter optimization
		int EDA_psize;
		// the maximum number of generations to evolve the best parameter set with EDA
		int EDA_maxgeno;
		// the maximum number of generations to evolve the best parameter set with CMA-ES
		int CMAES_maxgeno;

		// set a parameter value
		bool setParameter(char *name, char *value);

		// write parameter set to file
		void write(const char *filename);
};

#endif
